package org.expeditee.items.widgets;


import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;

import org.expeditee.items.Text;

public class SampleWidget2 extends InteractiveWidget {
	
	private JComboBox _combo;
	private JTextArea _text;
	
	public SampleWidget2(Text source, String[] args) {
		super(source, new JSplitPane(JSplitPane.VERTICAL_SPLIT), 60, -1, 40, -1);

		JSplitPane sp = (JSplitPane)super._swingComponent;
		
		JPanel p = new JPanel(new FlowLayout());

		JLabel lbl = new JLabel("This widget has multiple JComponents!");
		
		JButton button = new JButton("Click Me!");
		
		JButton button2 = new JButton("Or Me!");
		
		_text = new JTextArea();
		
		_combo = new JComboBox(new String[] {"Item 1", "Item 2", "Item 3", "Item 21", "Item 22", "Item 23", "Item 31", "Item 32", "Item 33", "Item 41", "Item 42", "Item 43"});
		
		p.add(lbl);
		p.add(_combo);
		p.add(button);
		p.add(button2);
		
		sp.setTopComponent(p);
		sp.setBottomComponent(_text);

		// Set state
		if (args != null && args.length >= 1) {
			
			int selectedItem = 0;
			
			// extract selected index
			if (args.length >= 1 && args[0] != null) {
				try {
					selectedItem = Integer.parseInt(args[0]);
				} catch (NumberFormatException e) {
					e.printStackTrace();
				}
			}
			
			if (selectedItem < 0) selectedItem = 0;
			else if (selectedItem >= _combo.getItemCount())
				selectedItem = _combo.getItemCount() - 1;
			
			_combo.setSelectedIndex(selectedItem);
			
			if (args.length >= 2 && args[1] != null) {
				_text.setText(args[1]);
			}
			
			if (args.length >= 3 && args[2] != null) {
				try {
					int div = Integer.parseInt(args[2]);
					((JSplitPane)super._swingComponent).setDividerLocation(div);
				} catch (NumberFormatException e) {}
				
			}
		}		
	}

	@Override
	protected String[] getArgs() {
		
		return new String[] { 
				Integer.toString(_combo.getSelectedIndex()),
				_text.getText(),
				Integer.toString(((JSplitPane)super._swingComponent).getDividerLocation())
			};
	}
}
